Imports System.Data.SqlClient
Imports System.Configuration

Module modCompatibility
    Public ConnStr As String = ConfigurationSettings.AppSettings("sqlconnect")
    'These Functions are provided to make conversion from Access to vb.net as easy as possible
    'Feel free to modify them in any way you see fit, as long as it is for your own use
    'Please do not publish these functions, unless you credit EvolutionSoft as the Authors

    Public Function GetDataSet(ByVal Sql As String, ByVal table As String) As DataSet
        'Returns a Populated Dataset - (Can be used with UpdateTable for Updating Row(s))
        Try
            If Sql = String.Empty Or table = String.Empty Then
                Return Nothing
                Exit Function
            End If
            Dim MyDS As New DataSet
            Dim myadapt As SqlDataAdapter
            Dim myconn As New SqlConnection(ConnStr)
            myadapt = New SqlDataAdapter(Sql, myconn)
            myconn.Open()
            myadapt.Fill(MyDS)
            Return MyDS
        Catch ex As Exception
            MsgBox("Error in GetDataSet - " & ex.Message, MsgBoxStyle.Critical, "Application Error")
            Return Nothing
        End Try
    End Function
    Public Function ExecuteNonQuery(ByVal Sql As String) As Boolean
        'Used to execute SQL Non Query Commands
        Try
            Dim connstr As String = ""
            Dim strSql As String
            Dim sqlConn As New SqlConnection(connstr)
            Dim SQLCmd As New SqlCommand

            With SQLCmd
                .Connection = sqlConn
                .Connection.Open()
                .CommandText = Sql
                .ExecuteNonQuery()
            End With
            Return True
        Catch ex As Exception
            MsgBox("Error in ExecuteNonQuery - " & ex.Message, MsgBoxStyle.Critical, "Application Error")
            Return False
        End Try
    End Function
    Public Function GetSchema(ByVal table As String) As DataSet
        'Returns a DataSet with only schema information (Use with updateTable for adding new rows)
        Try
            Dim sqlAdapt As SqlDataAdapter
            Dim sqlConn As SqlConnection
            Dim myBuild As SqlCommandBuilder
            Dim myDs As New DataSet
            sqlConn = New SqlConnection(ConnStr)
            sqlConn.Open()
            sqlAdapt = New SqlDataAdapter("select * from " & table & " where 1=0", sqlConn)
            sqlAdapt.FillSchema(myDs, SchemaType.Source, table)
            Return myDs
        Catch ex As Exception
            MsgBox("Error in GetSchema - " & ex.Message, MsgBoxStyle.Critical, "Application Error")
            Return Nothing
        End Try
    End Function
    Public Function UpdateTable(ByVal CreateNew As Boolean, ByVal myDS As DataSet) As String
        'Use with GetDataSet or GetSchema to perform Updates or Add new Rows
        Try
            Dim sqlAdapt As SqlDataAdapter
            Dim sqlConn As SqlConnection
            Dim myBuild As SqlCommandBuilder
            sqlConn = New SqlConnection(ConnStr)
            sqlConn.Open()
            sqlAdapt = New SqlDataAdapter("select * from " & myDS.Tables(0).TableName, sqlConn)
            myBuild = New SqlCommandBuilder(sqlAdapt)
            If CreateNew Then
                sqlAdapt.InsertCommand = myBuild.GetInsertCommand
            Else
                sqlAdapt.InsertCommand = myBuild.GetUpdateCommand
            End If

            sqlAdapt.Update(myDS.Tables(myDS.Tables(0).TableName))
            myDS.AcceptChanges()
        Catch ex As Exception
            MsgBox("Error in UpdateTable - " & ex.Message, MsgBoxStyle.Critical, "Application Error")
            Return String.Empty
        End Try
    End Function
    Friend Function Dcount(ByVal col As String, ByVal tab As String, ByVal where As String) As Integer
        'Provided as comptibility with Access Dcount function
        Try
            If where = String.Empty Then where = "1 = 1"
            If tab = String.Empty Then
                Return 0
            End If
            If col = String.Empty Then col = "*"
            Dim sqlConn As SqlConnection
            Dim sqlCom As SqlCommand

            sqlConn = New SqlConnection(ConnStr)
            sqlCom = New SqlCommand("select count(" & col & ") from " & tab & " where " & where, sqlConn)
            sqlConn.Open()
            Dcount = sqlCom.ExecuteScalar
            sqlConn.Close()
            sqlCom.Dispose()

        Catch ex As Exception
            MsgBox("Error in Dcount - " & ex.Message, MsgBoxStyle.Critical, "Application Error")
            Return 0
        End Try
    End Function

    Friend Function Dexists(ByVal tab As String, ByVal where As String) As Boolean
        'Provided as comptibility with Access DExists function
        Try
            If tab = String.Empty Or where = String.Empty Then
                Return False
                Exit Function
            End If
            Dim sqlconn As SqlConnection
            Dim sqlcom As SqlCommand
            Dim Mydr As SqlDataReader
            sqlconn = New SqlConnection(ConnStr)
            sqlcom = New SqlCommand("select * from " & tab & " where " & where, sqlconn)
            sqlconn.Open()
            Mydr = sqlcom.ExecuteReader(CommandBehavior.CloseConnection)
            If Mydr.Read Then
                Return True
            Else
                Return False
            End If
            sqlconn.Close()
            sqlcom.Dispose()
            Mydr.Close()
        Catch ex As Exception
            MsgBox("Error in Dexists - " & ex.Message, MsgBoxStyle.Critical, "Application Error")
            Return False
        End Try
    End Function

    Friend Function Dlookup(ByVal col As String, ByVal tab As String, ByVal where As String) As Object
        'Provided as comptibility with Access Dlookup function
        Try
            Dim myConn As New SqlConnection(ConnStr)
            Dim myCom As New SqlCommand("select " & col & " from " & tab & " where " & where, myConn)
            myConn.Open()
            Return myCom.ExecuteScalar
        Catch ex As Exception
            MsgBox("Error in Dlookup - " & ex.Message, MsgBoxStyle.Critical, "Application Error")
            Return Nothing
        End Try
    End Function

    Friend Function Dmax(ByVal col As String, ByVal tab As String, ByVal where As String) As Object
        'Provided as comptibility with Access Dmax function
        Try
            If where = String.Empty Then where = "1 = 1"
            If tab = String.Empty Or col = String.Empty Then
                Return String.Empty
                Exit Function
            End If
            Dim sqlConn As SqlConnection
            Dim sqlCom As SqlCommand
            sqlConn = New SqlConnection(ConnStr)
            sqlCom = New SqlCommand("select max(" & col & ") from " & tab & " where " & where, sqlConn)
            sqlConn.Open()
            Dmax = sqlCom.ExecuteScalar
            sqlConn.Close()
            sqlCom.Dispose()
        Catch ex As Exception
            MsgBox("Error in Dmax - " & ex.Message, MsgBoxStyle.Critical, "Application Error")
            Return ""
        End Try
    End Function

    Public Function Dmin(ByVal col As String, ByVal tab As String, ByVal where As String) As String
        'Provided as comptibility with Access Dmin function
        Try
            If where = String.Empty Then where = "1 = 1"
            If tab = String.Empty Or col = String.Empty Then
                Return String.Empty
                Exit Function
            End If
            Dim sqlConn As SqlConnection
            Dim sqlCom As SqlCommand

            sqlConn = New SqlConnection(ConnStr)
            sqlCom = New SqlCommand("select min(" & col & ") from " & tab & " where " & where, sqlConn)
            sqlConn.Open()
            Dmin = sqlCom.ExecuteScalar
            sqlConn.Close()
            sqlCom.Dispose()
        Catch ex As Exception
            MsgBox("Error in Dmin - " & ex.Message, MsgBoxStyle.Critical, "Application Error")
            Return ""
        End Try
    End Function

    Friend Function Dsum(ByVal col As String, ByVal tab As String, ByVal where As String) As Object
        'Provided as comptibility with Access Dsum function
        Try
            Dim sqlConn As SqlConnection
            Dim sqlcom As SqlCommand
            sqlConn = New SqlConnection(ConnStr)
            If where = String.Empty Then where = "1=1"
            sqlcom = New SqlCommand("select sum(" & col & ") from " & tab & " where " & where, sqlConn)
            sqlConn.Open()
            Dsum = sqlcom.ExecuteScalar
        Catch ex As Exception
            MsgBox("Error in Dsum - " & ex.Message, MsgBoxStyle.Critical, "Application Error")
            Dsum = 0
        End Try
    End Function

    Friend Function IsNull(ByVal expression As Object) As Boolean
        If expression Is DBNull.Value Then
            Return True
        Else
            Return False
        End If
    End Function
End Module
